; Programa: Ejemplo de agente bsico humano para jugar al Bumper Cars
;
; Asignatura: Introduccin a la Inteligencia Artificial
;             ETSII - ULL
; Prctica: 4a (sistemas de produccin)
; Profesor: Patricio Garca
; Fecha: 15/5/2003
; Comentarios:
;              Hace uso del package bumper
;              (load "bumper")
;


(use-package "bumper")

(defvar *version-agente-humano* "0.1" "Versin de agente-humano.lsp")


(defun car2num (car)
  "Transforma el caracter de entrada al nmero de movimiento"
  (case car
    ((n k) 1)
    ((j s) 2)
    ((l e) 3)
    ((h o) 4)))


; Agente humano
;--------------

(defun agente-humano ()
  "Agente humano para jugar al Bumper Cars"
  (let ((estr-ini (gen-bump)))
    (do ((solucion nil (cons mov solucion)))
        ; Salir cuando encontremos solucin, devolvindola
	((sol-val-bump estr-ini) (vis-bump estr-ini) (reverse solucion))
      (vis-bump estr-ini)
      ; Iterar hasta entrar un movimiento legal
      (loop 
	(format t "~%Movimiento (k=N,j=S,l=E,h=O)? ")
	(setf mov (car2num (read)))
	(if (not (mov-val-bump mov estr-ini))
	    (progn
	      (vis-bump estr-ini)
	      (format t "~%~s: movimiento no vlido" mov))
	  (progn
	    (setf (bump-cars estr-ini) (mov-bump mov estr-ini))
	    (return)))))))


; Para pruebas:
; -------------
;
; (load "bumper") (load "agente-humano")
;
; (inic-bump #'agente-humano :verb t)
; (inic-bump #'agente-humano :verb t :fich "lab1.bump")
; (inic-bump #'agente-humano :verb t :ord t)
; (inic-bump #'agente-humano :verb t :fich "*.bump")
